package helloworldubicollab;

import java.io.IOException;

import org.ubicollab.service.Commands;
import org.ubicollab.service.ServiceLink;
import org.ubicollab.service.settings.ServiceSettings;

public class HelloWorldServiceLink implements ServiceLink {
	private static final String proxyName = "HelloWorld";
	private ServiceSettings serviceSettings = new ServiceSettings();
	
	public HelloWorldServiceLink() {
		serviceSettings.set("URL to PPT application server", "http://www.ulv.no");
		serviceSettings.set("Refresh time", "80");
	}
	
	public String msgReceived(String msg) {
		System.out.println("[" + proxyName + "] MsgReceived: " + msg);
		
		if (Commands.commandIsGetSettings(msg)) {
			try {
				return serviceSettings.toXml();
			} catch (IOException e) {
				e.printStackTrace();
				return Commands.FAILURE;
			}
		} else if (Commands.commandIsSetSettings(msg)) {
			setSettingsFromIncomingMsg(msg);
			return Commands.CONFIRM;
		}
		
		return Commands.INVALID_COMMAND;
	}

	private void setSettingsFromIncomingMsg(String msg) {
		String settingsXml = Commands.getArgumentsFrom(msg);
		serviceSettings = new ServiceSettings(settingsXml);
	}

}
