package org.ubicollab.service.pptviewer;

/**
 * Entry point for the PptService.
 * Directs incoming messages either to the local PptServiceLink or to ServiceProxyClient for sending
 * to a remote PptService.
 */
import org.ubicollab.service.ServiceLink;
import org.ubicollab.service.settings.ServiceSettings;

public class PptService implements ServiceLink {
	public static final String SERVLET_ALIAS = "PptService";
	public static final String PPT_SERVICE_NAME = "PptService";
	
	private ServiceLink serviceLink;
	private ServiceSettings settings = new ServiceSettings();
	
	private int transferMethod;

	public PptService(int transferMethod) {
		setTransferMethod(transferMethod);
		createServiceLink(transferMethod);
	}

	public void setTransferMethod(int transferMethod) {
		if (this.transferMethod != transferMethod) {
			this.transferMethod = transferMethod;
			
		}
	}

	private void createServiceLink(int transferMethod) {
		serviceLink = ServiceLinkFactory.createServiceLink(settings, transferMethod);
	}

	public String msgReceived(String msg) {
		Debug.print("Message received: " + msg);
		String reply = serviceLink.msgReceived(msg);
		Debug.print("Returning: " + reply);
		return reply;
	}

}
