package org.ubicollab.service.pptviewer;

import org.ubicollab.core.service.proxy.ServiceProxyClient;
import org.ubicollab.service.ServiceLink;
import org.ubicollab.service.settings.ServiceSettings;

public class ServiceLinkFactory {
	
	public static ServiceLink createServiceLink(ServiceSettings settings, int transferMethod) {
		ServiceLink pptServiceLink;
		
		if (transferMethod == ServiceLink.TRANSFER_METHOD_DIRECT) {
			Debug.print("Creating ServiceLink with DIRECT transfer method.");
			pptServiceLink = createPptServiceLink(settings);
		} else if (transferMethod == ServiceLink.TRANSFER_METHOD_HTTP) {
			pptServiceLink = createRemotePptServiceLink();
		} else {
			Debug.print("Invalid transfer method!");
			throw new RuntimeException("Invalid transfer method");
		}
		
		return pptServiceLink;
	}

	private static ServiceLink createPptServiceLink(ServiceSettings settings) {
		ServiceLink pptServiceLink = new PptServiceLink(settings);
		return pptServiceLink;
	}

	private static ServiceLink createRemotePptServiceLink() {
		ServiceLink pptServiceLink;
		Debug.print("Creating ServiceLink with HTTP transfer method.");
		String remoteProxyUrl = "http://192.168.1.109:10123/pptViewerService"; // TODO
		pptServiceLink = new ServiceProxyClient(remoteProxyUrl);
		return pptServiceLink;
	}
	
}
