package org.ubicollab.app.pptviewer;

import java.util.HashMap;
import java.util.Iterator;

import org.ubicollab.view.servlet.HTMLPage;
import org.ubicollab.view.servlet.LinkedHTMLTemplate;

public class PageMainMenu extends LinkedHTMLTemplate {
	
	public static final String PAGE_ID = "MainMenu";
	
	private HashMap<HTMLPage, String> menuItems;
	
	public PageMainMenu() {
		this.menuItems = new HashMap<HTMLPage, String>();
	}
	
	@Override
	protected String getHTMLBody() {
		String content = "";
		content += "<p>";
		content += getHtmlMenu();
		content += "</p>";
		return content;
	}

	@Override
	protected String getTitle() {
		return "PptViewer";
	}
	
	@Override
	protected String getSubTitle() {
		return "Main menu";
	}
	

	public String getPageId() {
		return PAGE_ID;
	}

	
	private String getHtmlMenu() {
		String htmlMenu = "";
		Iterator<HTMLPage> iterator = menuItems.keySet().iterator();
		
		while (iterator.hasNext()) {
			HTMLPage htmlPage = iterator.next();
			htmlMenu += getMenuItemHtml(htmlPage);
		}

		return htmlMenu;
	}

	private String getMenuItemHtml(HTMLPage htmlPage) {
		String htmlPageId = htmlPage.getPageId();
		String description = menuItems.get(htmlPage);
		String htmlMenuItem = "<a href='" + getUrlTo(htmlPageId) + "'>" +
			description + "</a>";
		
		return htmlMenuItem;
	}

	public void addHtmlPageToMenu(HTMLPage htmlPage, String description) {
		menuItems.put(htmlPage, description);
	}


}
