package org.ubicollab.app.pptviewer;

import org.ubicollab.view.servlet.LinkedHTMLTemplate;

public class PageSelectPresentation extends LinkedHTMLTemplate {
	public static final String PAGE_ID = "SelectPresentation";
	
	// TODO: Get this from settings
	private final String customUrlToPpt = "http://folk.ntnu.no/yngvark/files/MSIS.ppt";
	

	@Override
	public String getHTMLBody() {
		String pptLoaderUrl = getUrlTo(PageViewPresentation.PAGE_ID);
		String pptLoaderParams = "&" + PageViewPresentation.PARAM_PPT_URL + "=' + urlToPpt";
		
		String content = "";
		content += "<p>";
		content += "Enter URL to PPT.";
		
		content += "<script type='text/javascript'>";
		content += "function fetchPpt(urlToPpt) {";
		content += "	document.location = '" + pptLoaderUrl + pptLoaderParams + ";";
		content += "}";
		content += "</script>";

		content += "<form name='myForm'>";
		content += "<input type='text' name='urlToPpt' " +
				"value='" + customUrlToPpt + "' />";
		content += "<input type='button' value='Fetch' " +
				"onClick='fetchPpt(myForm.urlToPpt.value)' />";
		content += "</form>";
		content += "</p>";
		
		content += "<p>";
		content += "<a href='" + getUrlTo(PageMainMenu.PAGE_ID) + "'>Go back</a>";
		content += "</p>";
		return content;
	}
	
	@Override
	protected String getTitle() {
		return "PPTViewer";
	}

	@Override
	protected String getSubTitle() {
		return "Select presentation to view";
	}

	public String getPageId() {
		return PAGE_ID;
	}

}
