package org.ubicollab.app.pptviewer;

import javax.servlet.http.HttpServletRequest;

import org.ubicollab.view.servlet.LinkedHTMLTemplate;

public class PageViewPresentation extends LinkedHTMLTemplate {
	
	public static final String PAGE_ID = "ViewPresentation";
	public static final String PARAM_PPT_URL = "pptUrl";
	private String urlToClientWebApp;
	private String subTitle;
	
	protected void init() {
		String pptUrl = getPptUrl();
		initUrlToClientWebApp(pptUrl);
		initSubTitle(pptUrl);
	}

	private void initUrlToClientWebApp(String pptUrl) {
		urlToClientWebApp = getUrlToClientWebApp(pptUrl);
	}

	private void initSubTitle(String pptUrl) {
		subTitle = "Viewing presentation at " + pptUrl;
	}
	
	@Override
	protected String getTitle() {
		return "PPTViewer";
	}

	@Override
	protected String getSubTitle() {
		return subTitle;
	}
	@Override
	public String getHTMLBody() {
		String content = "";
		content += "<p>";
		content += "<iframe src='" + urlToClientWebApp + "'>" +
				"Your browser must support iframes in order to view PPT.</iframe>";
		content += "</p>";
		content += "<p>";
		content += "<a href='" + getUrlTo(PageMainMenu.PAGE_ID) + "'>Go back</a>";
		content += "</p>";
		return content;
	}

	private String getPptUrl() {
		HttpServletRequest httpRequest = getHttpRequest(); 
		String pptUrl = httpRequest.getParameter(PARAM_PPT_URL);
		return pptUrl;
	}

	private String getUrlToClientWebApp(String pptUrl) {
		PptViewer pptViewer = Activator.getInstance().getPptViewer(); 
		return pptViewer.openPpt(pptUrl);
	}


	public String getPageId() {
		return PAGE_ID;
	}

}
