package org.knopflerfish.bundle.junit;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.util.Hashtable;

import org.knopflerfish.service.junit.JUnitService;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;


public class Activator implements BundleActivator {
	JUnitService junitService;
	static BundleContext	bc;
	static LogRef 			log;

	public void start(BundleContext bc) throws Exception {
		this.bc = bc;
		this.log = new LogRef();

		{
			junitService = new JUnitServiceImpl();

	    	Hashtable props = new Hashtable();
	    	bc.registerService(JUnitService.class.getName(), junitService, props);
	    }

	    tryObject("org.knopflerfish.bundle.junit.HttpExporter", "open");
	    //    httpExporter = new HttpExporter();
	    //    httpExporter.open();

	    // register to Knopflerfish console service if possible
	    tryObject("org.knopflerfish.bundle.junit.JUnitCommandGroup", "register");

	}

	public void stop(BundleContext bc) {
		this.bc = null;
	}

	class LogRef {
		public void info(String msg) {
			System.out.println("INFO: " + msg);
		}

		public void error(String msg, Throwable t) {
			System.out.println("ERROR: " + msg);
			if(t != null) {
				t.printStackTrace();
			}
		}
	}
	
	/**
	 * Try to create an instance of a named class and call a method in it.
	 * <p>
	 * This is done using reflection, since DynamicImport-Package won't
	 * resolve external bundles at the same time a bundle itself is in
	 * progress of being resolved.
	 * </p>
	 */
	void tryObject(String className, String methodName) {
		try {
			Class clazz = Class.forName(className);
			Constructor cons = clazz.getConstructor(new Class[] {
					BundleContext.class 
			});
			Object obj = cons.newInstance(new Object[] { bc });
			Method m = clazz.getMethod(methodName, null);
			m.invoke(obj, null);

			//      System.out.println("invoked " + m);
		}  catch (Throwable th) {
			//      System.out.println("No " + className + " available: " + th);
		}    
	}

}
