package org.ubicollab.core.sdm;

import java.util.Collection;
import java.util.Iterator;

import org.osgi.framework.BundleEvent;
import org.ubicollab.service.ServiceProxy;

public class Debug {
	
	private static final String APP_NAME = "SDM CORE";
	
	public static void printServices(Collection<ServiceProxy> services) {
		Debug.print("Printing services. Services found: " + services.size());
		Iterator<ServiceProxy> iter = services.iterator();

		while (iter.hasNext()) {
			Debug.print("- " + iter.next());
		}
	}

	public static String getEventAsTextFrom(int type) {
		switch (type) {
		case BundleEvent.INSTALLED:
			return "BundleEvent.INSTALLED";
		case BundleEvent.UNINSTALLED:
			return "BundleEvent.UNINSTALLED";
		case BundleEvent.UPDATED:
			return "BundleEvent.UPDATED";
		default:
			return "Unsignificant BundleEvent";
		}
	}

	public static void print(String msg) {
		System.out.println("[" + Debug.APP_NAME + "] " + msg);
		
	}

}
