/*
 * Copyright 2007 UbiCollab.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ubicollab.core.sdm;

/**
 * The Class GlobalSettings holds a set of constants that will be used by other classes
 * throughout the Service Domain Manager. This gives a single point of configuration.
 * 
 * @author Kim-Steve Johansen
 * @version 0.2
 * @since 0.1
 */
public class GlobalSettings {
	
	/** The Constant SOAP_SERVICE_NAME is the service name that will be exported. */
	public final static String SOAP_SERVICE_NAME = "serviceManager";
	
	/** The Constant STORAGE_ROOT holds the name of the ubicollab file folder. */
	public final static String STORAGE_ROOT = "/sdcard/ubifiles";
	
	/** The Constant LOG_FILE holds the name for the SR log file. */
	public final static String LOG_FILE = "log_servicedomain.xml";
	
	/** The Constant SELECTED_LOG_LEVEL decides which level to log. */
	public final static int SELECTED_LOG_LEVEL = Log.DEBUG;

	/** The Constant SERVICE_FILE holds filename for persistant starage of services. */
	public final static String SERVICE_FILE = "services.xml";

	/** The valid XML Header string. */
	public final static String XML_HEADER = "<?xml version='1.0'?>";
}
