package org.ubicollab.core.sdm.view.android;

import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.view.View;

import com.prosyst.mbs.android.application.ActivityWrapper;
import com.prosyst.mbs.android.application.ApplicationFactory;
import com.prosyst.mbs.android.application.CallbackHandler;

public class MyApplicationFactory implements ApplicationFactory {
	public static final String APP_NAME = "SDM";
	private static final String RES_IMAGES_ICON_GREEN =
		"/resources/greenled.png";
	static final String APP_TYPE = "org.ubicollab.core.sdm";

	private Bitmap icon;
  
	// This method is inherited from com.prosyst.mbs.android.application.ApplicationFactory.
	// It simply returns a GUI when the Bundle Activator starts the mBS activity.  
	public View createView(ActivityWrapper context, Intent starter, 
			CallbackHandler callbackHandler) {
		// Get Android application context
		// Context androidContext = context.getApplicationContext();
		
		// Create a GUI
		GUI gui = new WebGUI(); // Use HTML GUI
		View view = gui.createView(context);
		
		return view;
	}

	// This method provides a custom icon to represent the UI of this bundle
	public Bitmap getIcon() {
		if (icon == null) {
			icon = BitmapFactory.decodeStream(
					//MyOSGiAndroidApp.class.getResourceAsStream(RES_IMAGES_ICON_GREEN));
					Activator.class.getResourceAsStream(RES_IMAGES_ICON_GREEN));
		}
		return icon;
	}

	// This method specifies the main application type of the bundle
	public String getMainType() {
		return APP_TYPE;
	}

	//This method specifies the friendly name of this bundle. It will be available in 
	// the Android desktop under this name.
	public String getName() {
		return APP_NAME;
	}

	// This method returns the main application types supported by this bundle.
	public String[] getSuportedTypes() {    
		return new String[] {APP_TYPE};
	}
}
