package org.ubicollab.core.sdm.view.android;

import android.view.View;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.widget.LinearLayout;

import com.prosyst.mbs.android.application.ActivityWrapper;

public class WebGUI implements GUI {
	private String guiURL; // TODO: Get this from some service
	private final String SERVLET_ALIAS = "/sdm"; // TODO: Get this from some service
	
	public WebGUI() {
		// 1149 is the default port for mBS Mobile for Android Runtime.
		String httpPort = System.getProperty("org.osgi.service.http.port", "1149");
		// Set URL for the GUI.
		guiURL = "http://localhost:" + httpPort + SERVLET_ALIAS + "?pageRequested10391683=MainMenu";	
	}

	public View createView(ActivityWrapper context) {
		// Creating a WebGUI

		// Create a Linear Layout
		LinearLayout layout = new LinearLayout(context);
		// Create a WebView
		View viewContents = createWebView(context);

		// Put the WebView in the LinearLayout
		layout.addView(viewContents);
		return layout;
	}
	
	/* 
	 * Shows a standard HTML error page.
	 * TODO: Show message in the web page some way (dynamic content stuff).
	 */
	public void showError(String message) {
		Debug.print("[GUI ERROR] " + message);
	}

	/*
	 * Creates a WebView for showing web page content.
	 */
	private WebView createWebView(ActivityWrapper context) {
		// Create WebView.
		WebView webView = new WebView(context);
		webView.getSettings().setJavaScriptEnabled(true);
		// TODO: For Android 2.1, set zoom settings so that when page changes, the zoom
		// distance is not increased. I haven't figured out how to do that yet.
		// TODO: Why doesn't this work??? Every time I click a link, the page is zooming
		// out way too far.
		webView.getSettings().setDefaultZoom(WebSettings.ZoomDensity.CLOSE);

        
        // Load a HTML page in browser
		Debug.print("Loading web page: " + guiURL);
		webView.loadUrl(guiURL);
		Debug.print("Web page loaded!");

        return webView;
	}
	

}
