package org.ubicollab.core.sdm.view.servlet;

import org.ubicollab.core.sdm.view.servlet.pages.*;
import org.ubicollab.view.servlet.GUIServlet;
import org.ubicollab.view.servlet.LinkedHTMLTemplate;

@SuppressWarnings("serial")
public class SDMServlet extends GUIServlet {
	public static final String SDM_PAGE_TITLE = "Service Domain Manager";
	
	private static final String servletAlias = "sdm";
	private PageMainMenu pageMainMenu;
	
	public SDMServlet()
	{
		super(SDMServlet.servletAlias, Activator.getBundleContext());
	}

	@Override
	// TODO: It should be possible to create pages within pages, i.e. a container style like
	// Java Swing containers, or the Composite design pattern. At the moment all pages must be
	// created using a GUIServlet.
	public void registerHttpServlet() {
		pageMainMenu = new PageMainMenu();
		addHtmlPage(pageMainMenu);

		//addHtmlPage(pageViewServices);
		
		// Pages in main menu.
		LinkedHTMLTemplate pageViewAllServices = new PageViewAllServices();
		pageMainMenu.addHtmlPageToMenu(pageViewAllServices, "View all services");
		addHtmlPage(pageViewAllServices);
		
		LinkedHTMLTemplate pageMyNearbyServices = new PageMyNearbyServices();
		pageMainMenu.addHtmlPageToMenu(pageMyNearbyServices, "My nearby services");
		addHtmlPage(pageMyNearbyServices);
		
		LinkedHTMLTemplate pageMySharedServices = new PageMySharedServices();
		pageMainMenu.addHtmlPageToMenu(pageMySharedServices, "My shared services");
		addHtmlPage(pageMySharedServices);
		
		LinkedHTMLTemplate pageCategrByPlace = new PageCategrByPlace();
		pageMainMenu.addHtmlPageToMenu(pageCategrByPlace, "Categorized by place");
		addHtmlPage(pageCategrByPlace);
		
		LinkedHTMLTemplate pageCategrByType = new PageCategrByType();
		pageMainMenu.addHtmlPageToMenu(pageCategrByType, "Categorized by type");
		addHtmlPage(pageCategrByType);

		// Other pages.
		LinkedHTMLTemplate pageViewServicesInPlace =
			new PageViewServicesInPlace();
		addHtmlPage(pageViewServicesInPlace);
		
		LinkedHTMLTemplate pageViewServicesWithType = new PageViewServicesWithType();
		addHtmlPage(pageViewServicesWithType);

		LinkedHTMLTemplate pageViewServiceActions = new PageViewServiceActions();
		addHtmlPage(pageViewServiceActions);
		
		LinkedHTMLTemplate pageSaveServiceProperties = new PageSaveServiceProperties();
		addHtmlPage(pageSaveServiceProperties);
		
		// Pages linked to from PageViewServiceActions
		LinkedHTMLTemplate pageStartServiceAction = new PageStartServiceAction();
		addHtmlPage(pageStartServiceAction);
		
		LinkedHTMLTemplate pageStopServiceAction = new PageStopServiceAction();
		addHtmlPage(pageStopServiceAction);
		
		LinkedHTMLTemplate pageUninstallServiceAction = new PageUninstallServiceAction();
		addHtmlPage(pageUninstallServiceAction);
		
		LinkedHTMLTemplate pageSeeDescriptionAction = new PageSeeDescriptionAction();
		addHtmlPage(pageSeeDescriptionAction);
		
		LinkedHTMLTemplate pageEditServiceProperties = new PageEditServiceProperties();
		addHtmlPage(pageEditServiceProperties);
		
		super.registerHttpServlet();
	}

}
