package org.ubicollab.core.sdm.view.servlet.form;

import javax.servlet.http.HttpServletRequest;

import org.ubicollab.core.sdm.view.servlet.pages.HTMLBuilder;
import org.ubicollab.view.servlet.HTMLPage;

public class HTMLForm implements HTMLPage {
	public static final String PAGE_ID = "HTMLForm";
	public static final String METHOD_GET = "GET";
	
	private HTMLBuilder htmlBuilder;
	private String method = "";
	private String actionUrl = "";
	
	public HTMLForm() {
		htmlBuilder = new HTMLBuilder();
		getStartOfForm();
	}

	private String getStartOfForm() {
		HTMLBuilder startHtmlBuilder = new HTMLBuilder();
		startHtmlBuilder.addHtml("<form method='" + method + "' action='" + actionUrl + "'>");
		return startHtmlBuilder.getHtml();
	}

	private String getEndOfForm() {
		String submitName = ServiceSettingsFormBuilder.FORM_ELEMENT_PREFIX + "submit";
		HTMLBuilder endHtmlBuilder = new HTMLBuilder();
		endHtmlBuilder.addHtml("<p>");
		endHtmlBuilder.addLine("<input type='submit' name='" + submitName + "'>");
		endHtmlBuilder.addHtml("</p>");
		endHtmlBuilder.addHtml("</form>");
		return endHtmlBuilder.getHtml();
	}
	
	public String getHtml() {
		String htmlForm = "";
		htmlForm += getStartOfForm();
		htmlForm += htmlBuilder.getHtml();
		htmlForm += getEndOfForm();
		
		return htmlForm;
	}

	public String getPageId() {
		return PAGE_ID;
	}

	public void setHttpRequest(HttpServletRequest httpRequest) {

	}

	public void addTextField(LabeledTextField textField) {
		htmlBuilder.addHtml("<p>");
		htmlBuilder.addLabeledTextField(textField);
		htmlBuilder.addHtml("</p>");
	}
	
	public void addHiddenField(String name, String value) {
		htmlBuilder.addHtml("<input type='hidden' name='" + name + "' value='" + value + "' />");
	}

	public void setMethod(String method) {
		if (method.equals(METHOD_GET))
			this.method = METHOD_GET;
	}

	public void setAction(String actionUrl) {
		this.actionUrl = actionUrl;
	}

}
