package org.ubicollab.core.sdm.view.servlet.form;
import java.util.HashSet;
import java.util.Random;


public class UniqueStringFactory {
	private static HashSet<String> usedStrings = new HashSet<String>();
	
	public static String createUniqueString() {
		String uniqueString;
		do {
				uniqueString = generateRandomString();
		} while (exists(uniqueString));
		
		markAsUsed(uniqueString);
		return uniqueString;
	}

	private static String generateRandomString() {
		Random r = new Random();
		String uniqueString = Long.toString(Math.abs(r.nextLong()), 13);
		return uniqueString;
	}	

	private static boolean exists(String uniqueString) {
		return usedStrings.contains(uniqueString);
	}
	
	private static void markAsUsed(String uniqueString) {
		usedStrings.add(uniqueString);
	}

	
	public static void main(String[] args) {
		System.out.println(UniqueStringFactory.createUniqueString());
	}

}
