package org.ubicollab.core.sdm.view.servlet.pages;

import java.util.Collection;
import java.util.Iterator;

import org.ubicollab.core.sdm.DomainManager;
import org.ubicollab.core.sdm.view.servlet.Activator;
import org.ubicollab.core.sdm.view.servlet.SDMServlet;
import org.ubicollab.service.ServiceProxy;
import org.ubicollab.view.servlet.LinkedHTMLTemplate;

public class PageMyNearbyServices extends LinkedHTMLTemplate {

	private static final String PAGE_ID = "PageMyNearbyServices";
	private DomainManager domainManager;

	public PageMyNearbyServices() {
		this.domainManager = Activator.getDomainManager();
	}
	
	@Override
	protected String getTitle() {
		return SDMServlet.SDM_PAGE_TITLE;
	}

	@Override
	protected String getSubTitle() {
		return "My nearby services";
	}

	public String getPageId() {
		return PAGE_ID;
	}

	@Override
	protected String getHTMLBody() {
		String html = "";
		
		html += getServicesAsHtmlList();
		
		html += "<p>";
		html += "<a href='" + getUrlTo(PageMainMenu.PAGE_ID) + "'>" +
			"Go back</a> ";
		html += "</p>";
		
		return html;
		
	}

	private String getServicesAsHtmlList() {
		Collection<ServiceProxy> nearbyServices = domainManager.getNearbyServices();
		
		Iterator<ServiceProxy> serviceIter = nearbyServices.iterator();
		String htmlServiceList = "";
		while (serviceIter.hasNext()) {
			htmlServiceList += createLinkTo(serviceIter.next());
		}
		
		return htmlServiceList;
	}
	
	private String createLinkTo(ServiceProxy serviceProxy) {
		String urlToServiceView = getUrlTo(PageViewServiceActions.PAGE_ID);
		String htmlLink =
			HTMLBuilder.createAHref(urlToServiceView, serviceProxy.getName()) + "<br/>";
		
		return htmlLink;
	}
	
}
