package org.ubicollab.core.sdm.view.servlet.pages;

import org.ubicollab.core.sdm.view.servlet.SDMServlet;
import org.ubicollab.service.ServiceProxy;
import org.ubicollab.view.servlet.LinkedHTMLTemplate;

public class PageSeeDescriptionAction extends LinkedHTMLTemplate  {

	public static final String PAGE_ID = "PageSeeDescriptionAction";
	
	private ServiceProxy selectedServiceProxy; 
	private String htmlReply = "";
	private String serviceDescription = "Error: Not set";
	
	public PageSeeDescriptionAction() {
	}
	
	@Override
	protected void init() {
		htmlReply = "";
		getServiceProxy();
		getServiceDescription();
		addDescription();
	}

	private void getServiceProxy() {
		selectedServiceProxy = ReferencedServices.getLastReferencedServiceProxy();
	}

	private void getServiceDescription() {
		serviceDescription = selectedServiceProxy.getDescription();
	}

	private void addDescription() {
		addLine("<h3>Service description</h3>");
		String desc = "\"<i>" + serviceDescription + "</i>\"";
		addLine(desc);
		addGoBackLink();
	}

	
	private void addLine(String line) {
		addHtml(line + "<br/>"); 
	}

	private void addHtml(String html) {
		htmlReply += html;
	}

	private void addGoBackLink() {
		addHtml("<p><a href='" + getUrlTo(PageViewServiceActions.PAGE_ID) + "'>Go back</a></p>");
	}

	@Override
	protected String getTitle() {
		return SDMServlet.SDM_PAGE_TITLE;
	}

	@Override
	protected String getSubTitle() {
		return "Viewing service description";
	}

	public String getPageId() {
		return PAGE_ID;
	}

	@Override
	protected String getHTMLBody() {
		return htmlReply;
	}

}
