package org.ubicollab.core.sdm.view.servlet.pages;

import java.util.Collection;

import org.ubicollab.core.sdm.DomainManager;
import org.ubicollab.core.sdm.view.servlet.Activator;
import org.ubicollab.core.sdm.view.servlet.SDMServlet;
import org.ubicollab.service.ServiceProxy;

public class PageViewAllServices extends PageViewServices  {

	public static final String PAGE_ID = "PageViewAllServices";
	
	private DomainManager domainManager;
	
	public PageViewAllServices() {
		this.domainManager = Activator.getDomainManager();
	}
	
	@Override
	protected String getTitle() {
		return SDMServlet.SDM_PAGE_TITLE;
	}

	@Override
	protected String getSubTitle() {
		return "Viewing all serices";
	}

	public String getPageId() {
		return PAGE_ID;
	}

	@Override
	protected String getHTMLBody() {
		setServicesToView();
		return super.getHTMLBody();
	}

	private void setServicesToView() {
		Collection<ServiceProxy> allServices = domainManager.getServices();		
		setServices(allServices);
	}


}
