package org.ubicollab.core.sdm.view.servlet.pages;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import org.ubicollab.core.sdm.view.servlet.Debug;
import org.ubicollab.core.sdm.view.servlet.SDMServlet;
import org.ubicollab.service.ServiceProxy;
import org.ubicollab.view.servlet.LinkedHTMLTemplate;

public class PageViewServices extends LinkedHTMLTemplate {

	public static final String PAGE_ID = "PageViewServices";
	
	private Collection<ServiceProxy> servicesToView = new ArrayList<ServiceProxy>();
	
	public PageViewServices() {
	}
	
	@Override
	protected String getTitle() {
		return SDMServlet.SDM_PAGE_TITLE;
	}

	@Override
	protected String getSubTitle() {
		return "View services";
	}

	public String getPageId() {
		return PAGE_ID;
	}

	@Override
	protected String getHTMLBody() {
		String html = "";
		html += getServicesAsHtmlList();
		html += getGoBackLink();
		
		return html;
	}
	
	private String getServicesAsHtmlList() {
		Iterator<ServiceProxy> serviceIter = servicesToView.iterator();
		String htmlServiceList = "";
		while (serviceIter.hasNext()) {
			htmlServiceList += createLinkTo(serviceIter.next());
		}
		
		return htmlServiceList;
	}
	
	private String createLinkTo(ServiceProxy serviceProxy) {
		String urlToServiceActions = getUrlTo(PageViewServiceActions.PAGE_ID);
		String getParams = getGetParamsFor(serviceProxy);
		String fullUrlToServiceActions = urlToServiceActions + "&" + getParams;
		
		String htmlLink =
			HTMLBuilder.createAHref(fullUrlToServiceActions, serviceProxy.getName()) + "<br/>";
		
		return htmlLink;
	}

	private String getGetParamsFor(ServiceProxy serviceProxy) {
		String getParams =
			PageViewServiceActions.PARAM_SERVICE_HASH_CODE + "=" + serviceProxy.hashCode();
		return getParams;
	}

	public void setServices(Collection<ServiceProxy> services) {
		// store services in serviceStorage for later retrieval
		ReferencedServices.storeServiceReferencesTo(services);
		this.servicesToView = services;
	}

	protected String getGoBackLink() {
		String html = "<p><a href='" + getUrlTo(PageMainMenu.PAGE_ID) + "'>" +
			"Go back</a></p>";
		
		return html;
	}

}
