package org.ubicollab.core.sdm.view.servlet.pages;

import java.util.Collection;

import org.ubicollab.core.sdm.DomainManager;
import org.ubicollab.core.sdm.view.servlet.Activator;
import org.ubicollab.core.sdm.view.servlet.SDMServlet;
import org.ubicollab.service.ServiceProxy;
import org.ubicollab.service.ServiceType;

public class PageViewServicesWithType extends PageViewServices  {

	public static final String PAGE_ID = "PageViewServicesWithType";
	public static final String PARAM_TYPE_NAME_TO_VIEW = "typeNameToView";
	
	private DomainManager domainManager;
	
	public PageViewServicesWithType() {
		this.domainManager = Activator.getDomainManager();
	}
	
	@Override
	protected String getTitle() {
		return SDMServlet.SDM_PAGE_TITLE;
	}

	@Override
	protected String getSubTitle() {
		return "Viewing services categorized by their type";
	}

	public String getPageId() {
		return PAGE_ID;
	}

	@Override
	protected String getHTMLBody() {
		String nameOfTypeToView = getHttpRequest().getParameter(PARAM_TYPE_NAME_TO_VIEW);
		
		if (nameOfTypeToView == null) {
			String html = "";
			html += "Missing GET parameter for which type to view.<br />";
			html += getGoBackLink();
			
			return html;
		} else {
			setServicesToView(nameOfTypeToView);
			return super.getHTMLBody();
		}
	}


	@Override
	protected String getGoBackLink() {
		String html = "<p><a href='" + getUrlTo(PageCategrByType.PAGE_ID) + "'>" +
			"Go back</a></p>";
		
		return html;
	}

	private void setServicesToView(String nameOfTypeToView) {
		ServiceType typeToViewServicesFor = domainManager.getServiceTypeByName(nameOfTypeToView);
		
		Collection<ServiceProxy> serviceProxiesWithTheSelectedType =
			domainManager.getServicesWithType(typeToViewServicesFor);
		
		setServices(serviceProxiesWithTheSelectedType);
	}

}
