package org.ubicollab.service;

import org.ubicollab.service.exception.NoTextAfterFirstSpaceException;

public class Commands {

	public static final String CONFIRM = "OK";
	public static final String GET_SETTINGS = "getSettings";
	public static final String SET_SETTINGS = "setSettings";
	public static final String FAILURE = "failure";
	public static final String INVALID_COMMAND = "invalidCommand";
	
	public static boolean commandIsGetSettings(String string) {
		return isCommandFirstWordOfString(GET_SETTINGS, string);
	}
	
	public static boolean commandIsSetSettings(String string) {
		return isCommandFirstWordOfString(SET_SETTINGS, string);
	}

	public static boolean isCommandFirstWordOfString(String cmd, String string) {
		String firstWord;
		try {
			firstWord = string.substring(0, cmd.length()); 
		} catch (IndexOutOfBoundsException e) {
			return false;
		}
		
		if (firstWord.equals(cmd))
			return true;
		else
			return false;
	}

	public static String getArgumentsFrom(String msg)
	throws NoTextAfterFirstSpaceException
	{
		int indexOfFirstSpace = msg.indexOf(" ", 1);
		if (indexOfFirstSpace == -1)
			throw new NoTextAfterFirstSpaceException();
		indexOfFirstSpace++; // move pointer to letter after space
		
		return msg.substring(indexOfFirstSpace);
	}

	public static String buildCommand(String command, String params) {
		return command + " " + params;
	}

}
