package org.ubicollab.service;

import java.util.Properties;

import org.osgi.framework.BundleContext;

public class ServiceLinkRegisterer {
	static final String OSGI_SERVICES_ID_PROPERTY_NAME = "org.ubicollab.service.type";
	static final String OSGI_SERVICES_ID_VALUE = "Ubicollab_0dm48imdl59gk";
	
	static final String UBICOLLAB_BUNDLE_ID_PROPERTY_NAME = "org.ubicollab.service.bundleId";
	
	private static BundleContext bundleContext;
	private static ServiceLink instanceToRegister;
	private static String className;
	private static Properties ubicollabProperties;
	
	public static boolean registerOsgiService(
			BundleContext bundleContext,
			ServiceLink instanceToRegister,
			String className
			)
	{
		return registerOsgiService(bundleContext, instanceToRegister, className, new Properties());
	}
	
	public static boolean registerOsgiService(
			BundleContext bundleContext,
			ServiceLink instanceToRegister,
			String className,
			Properties osgiProperties)
	{
		init(bundleContext, instanceToRegister, className, osgiProperties);
		boolean serviceWasRegistered = tryToregisterService();

		return serviceWasRegistered;
	}

	private static void init(
			BundleContext bundleContext,
			ServiceLink instanceToRegister,
			String className,
			Properties osgiProperties) 
	{
		ServiceLinkRegisterer.bundleContext = bundleContext;
		ServiceLinkRegisterer.instanceToRegister = instanceToRegister;
		ServiceLinkRegisterer.className = className;
		createUbicollabServicePropertiesFrom(osgiProperties);
	}

	private static void createUbicollabServicePropertiesFrom(Properties osgiProperties) {
		ubicollabProperties = new Properties(osgiProperties);
		ubicollabProperties.put(OSGI_SERVICES_ID_PROPERTY_NAME, OSGI_SERVICES_ID_VALUE);
		
		long bundleId = bundleContext.getBundle().getBundleId();
		ubicollabProperties.put(UBICOLLAB_BUNDLE_ID_PROPERTY_NAME, bundleId);
		
	}

	private static boolean tryToregisterService()
	{
		try {
			registerService();
			return true;
		} catch (IllegalStateException e) {
			e.printStackTrace();
			return false;
		}
	}

	private static void registerService() throws IllegalStateException {
		bundleContext.registerService(
				className, instanceToRegister, ubicollabProperties);
	}

}
