package org.ubicollab.service;

import java.util.ArrayList;
import java.util.Iterator;

import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;

public class ServiceProxyFinder {
	
	public static ArrayList<ServiceProxy> searchForUbicollabServices
	(BundleContext bundleContext)
	{
		Bundle[] allBundles = bundleContext.getBundles();
		
		ArrayList<Bundle> ubicollabBundles = searchForUbicollabBundles(allBundles);
		ArrayList<ServiceProxy> ubicollabProxies =
			convertBundlesToServiceProxies(ubicollabBundles);
		
		return ubicollabProxies;
	}

	private static ArrayList<Bundle> searchForUbicollabBundles(Bundle[] bundles) {
		ArrayList<Bundle> ubicollabBundlesArrList = new ArrayList<Bundle>();
		
		for (int i = 0; i < bundles.length; i++) {
			if (isAnUbciollabService(bundles[i])) {
				ubicollabBundlesArrList.add(bundles[i]);
			}
		}
		
		return ubicollabBundlesArrList; 
	}

	public static boolean isAnUbciollabService(Bundle bundle) {
		String bundleSymbolicName = bundle.getSymbolicName();

		boolean bundleSymbolicNameIsLongEnoughForAnUbicollabService =
			bundleSymbolicNameIsLongEnoughForAnUbicollabService(bundleSymbolicName);
		
		if (! bundleSymbolicNameIsLongEnoughForAnUbicollabService) {
			return false;
		}
		
		boolean bundleSymbolicNameEqualsTheUbciollabSymbolicName =
			bundleSymbolicNameEqualsTheUbciollabSymbolicName(bundleSymbolicName);
		
		if (! bundleSymbolicNameEqualsTheUbciollabSymbolicName) {
			return false;
		}
		
		return true;
	}

	private static boolean bundleSymbolicNameIsLongEnoughForAnUbicollabService(String bundleSymbolicName) {
		boolean result  =
			strOneIsLongerThanStrTwo(
					bundleSymbolicName,
					ServiceProxyFactory.SYMBOLIC_NAME_FOR_UBICOLLAB_SERVICES
					);
		
		return result;
	}	

	private static boolean bundleSymbolicNameEqualsTheUbciollabSymbolicName(String bundleSymbolicName) {
		String startOfBundleSymbolicName = getStartOfBundleSymbolicName(bundleSymbolicName);
		
		boolean bundleSymbolicNameEqualsTheUbciollabSymbolicName =
			startOfBundleSymbolicName.equals(ServiceProxyFactory.SYMBOLIC_NAME_FOR_UBICOLLAB_SERVICES);
		return bundleSymbolicNameEqualsTheUbciollabSymbolicName;
	}


	private static boolean strOneIsLongerThanStrTwo(String stringOne, String stringTwo) {
		return stringOne.length() > stringTwo.length();
	}

	private static String getStartOfBundleSymbolicName(String bundleSymbolicName) {
		int endIndex = getSmallestStringLength(
				ServiceProxyFactory.SYMBOLIC_NAME_FOR_UBICOLLAB_SERVICES, bundleSymbolicName);
		
		String startOfBundleSymbolicName = bundleSymbolicName.substring(0, endIndex);
		
		return startOfBundleSymbolicName;
	}

	private static int getSmallestStringLength(String aString, String anotherString) {
		int smallestStringLength =
			aString.length() < anotherString.length() ? aString.length() : anotherString.length();
			
		return smallestStringLength;
	}

	private static ArrayList<ServiceProxy> convertBundlesToServiceProxies(
			ArrayList<Bundle> ubicollabBundles)
	{
		ArrayList<ServiceProxy> ubiServices = new ArrayList<ServiceProxy>(); 
		
		Iterator<Bundle> iter = ubicollabBundles.iterator();
		while (iter.hasNext()) {
			Bundle curBundle = iter.next();
			
			ServiceProxy ubiService =
				ServiceProxyFactory.createUbicollabServiceFrom(curBundle);
			ubiServices.add(ubiService);
		}
		
		return ubiServices;
	}

}
