package org.ubicollab.service;

import java.io.IOException;

import org.ubicollab.service.settings.ServiceSettings;

public class SettingsHandlerServiceLink implements ServiceLink {
	private ServiceSettings serviceSettings;

	public SettingsHandlerServiceLink(ServiceSettings serviceSettings) {
		this.serviceSettings = serviceSettings;
	}
	
	public String msgReceived(String msg) {
		if (Commands.commandIsGetSettings(msg)) {
			return commandIsGetSettings();
		} else if (Commands.commandIsSetSettings(msg)) {
			return commandIsSetSettings(msg);
		} else {
			return Commands.INVALID_COMMAND;
		}
	}

	private String commandIsGetSettings() {
		try {
			return serviceSettings.toXml();
		} catch (IOException e) {
			e.printStackTrace();
			return Commands.FAILURE;
		}
	}

	private String commandIsSetSettings(String msg) {
		String settingsXml = Commands.getArgumentsFrom(msg);
		serviceSettings = new ServiceSettings(settingsXml);
		return Commands.CONFIRM;
	}
	
	void setSetting(String key, String value) {
		serviceSettings.set(key, value);
	}
	
	String getSetting(String key) {
		return serviceSettings.get(key);
	}
		
}
