package org.ubicollab.core.sm.model;

import java.util.ArrayList;
import java.util.Random;

public class Space {
	private long id;
	private String name;
	private static ArrayList<Long> usedIds = new ArrayList<Long>();
	
	public Space() {
		id = generateUniqueId();
		name = "DummySpace" + id;
		SpaceManagerDummy.addSpaceToRegister(this);
	}
	
	private long generateUniqueId() {
		Random r = new Random();
		Long newId;
		do {
			newId = r.nextLong();
		} while (usedIds.contains(newId)); 
		
		return newId;
	}

	public boolean equals(Space otherSpace) {
		return getId() == otherSpace.getId();
	}
	
	public String toString() {
		return "space:{id=" + getId() + ",name=" + getName() + "}";
	}

	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	
}
