package org.ubicollab.testing.sdm.junit;

import java.util.Properties;
import junit.framework.Test;
import org.osgi.framework.BundleContext;


/**
 * This class is a wrapper for a JUnit test that is to be registered in the OSGi framework.
 * Registering a JUnit test in the OSGi framework enables the org.knopflerfish.bundle.junit bundle
 * to run the JUnit test.
 * 
 * @author Yngvar Kristiansen
 */
public class OsgiJunitTest {

	private BundleContext bundleContext;

	public OsgiJunitTest(BundleContext bundleContext) {
		this.bundleContext = bundleContext;
	}

	public void registerTestAsOSGiService(Test test, String testName)  {
		Properties serviceProperties = createServiceProperties(testName);
	    bundleContext.registerService(Test.class.getName(), test, serviceProperties);
	}

	private Properties createServiceProperties(String testName) {
		Properties serviceProperties = new Properties();
		// Needed by org.knopflerfish.bundle.junit in order to recognize the service as a JUnit
		// test.
	    serviceProperties.put("service.pid", testName);
		return serviceProperties;
	}

}
