package org.ubicollab.view.servlet;

import javax.servlet.http.HttpServletRequest;

public abstract class HTMLTemplate implements HTMLPage {
	private HttpServletRequest httpRequest;
	
	protected abstract String getTitle();

	protected abstract String getSubTitle();
	
	/*
	 * Provides the header and footer for the actual HTML content (implemented by
	 * sub classes).
	 */
	public String getHtml() {
		init();
		
		String html = "";
		html += "<HTML><HEAD><TITLE>";
		html += getTitle();
		html += "</TITLE></HEAD><BODY TEXT='#000000' BGCOLOR='#F9F9F9'>";
		html += "<font size='+2'><b>" + getTitle() + "</b></font><br />";
		html += "<font color='#A3A3A3' size='2'>" + getSubTitle() + "</font><br/>";
		html += getHTMLBody();
		html += "</BODY></HTML>";
		return html;
	}
	
	public void setHttpRequest(HttpServletRequest httpRequest) {
		this.httpRequest = httpRequest;
	}
	
	public HttpServletRequest getHttpRequest() {
		return httpRequest;
	}

	protected void init() {
		
	}
	
	protected abstract String getHTMLBody();


}
