package org.ubicollab.view.servlet;

import java.util.HashMap;

/*
 * Manages a mapping between HTMLPages and URLs.
 */
public class URLHandler {
	
	private HashMap<String, String> urlFromPageId;
	private String baseUrl;

	public URLHandler(String baseUrl) {
		this.urlFromPageId = new HashMap<String, String>();
		this.baseUrl = baseUrl;
	}

	public String getPageUrlFrom(String pageId) {
		if (urlFromPageId.containsKey(pageId)) {
			String pageUrl = urlFromPageId.get(pageId);
			String fullUrl = getFullUrl(pageUrl);
			return fullUrl;
		} else {
			Debug.print("Error: No URL stored for page with pageId: " + pageId);
			return "noSuchUrL"; // TODO: Should return URL to a error page.
		}
	}
	
	
	private String getFullUrl(String pageUrl) {
		return baseUrl + "/" + pageUrl;
	}

	public void setPageUrl(HTMLPage htmlPage, String pageUrl) {
		urlFromPageId.put(htmlPage.getPageId(), pageUrl);
	}

}
