<?php
class ErrorController {
	private $errors;
	private static $instance = null;
	
	private function ErrorController() {
		$this->errors = array();
	}
	
	public function getErrors() {
		return $this->errors;
	}
	
	public function addError($err) {
		array_push($this->errors, $err);
	}
	
	public function isErrors() {
		return sizeof($this->errors) > 0;
	}
	
	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new ErrorController();
		}
		
		return self::$instance;
	}

	public function getErrorsAsHtml() {
		require_once("HtmlPageBuilder.php");
		$htmlPageBuilder = new HtmlPageBuilder();
		
		$htmlPageBuilder->addHtml("<h1>Error</h1>");
		foreach ($this->getErrors() as $err) {
			$htmlPageBuilder->addHtml("- " . $err . "<br />");
		}
		
		return $htmlPageBuilder->getHtmlPage();
	}
}